﻿EngineStarterSpec = {
	specEntryName = string.format("spec_%s.engineStarterSpec", g_currentModName)
}

function EngineStarterSpec.prerequisitesPresent(specializations)
	return true
end

function EngineStarterSpec.registerEventListeners(vehicleType)
	SpecializationUtil.registerEventListener(vehicleType, "onLoad", EngineStarterSpec)
	SpecializationUtil.registerEventListener(vehicleType, "onEnterVehicle", EngineStarterSpec)
end

function EngineStarterSpec:onLoad(savegame)
	-- Should discharge stop when disconnected?
	-- if self.spec_dischargeable and self.spec_dischargeable.stopDischargeOnDeactivate == true then
		-- self.spec_dischargeable.stopDischargeOnDeactivate = false
	-- end
	-- if self.spec_dischargeable ~= nil then
		-- self.onDeactivate = Utils.overwrittenFunction(self.onDeactivate, function (self, superFunc)
			-- if g_engineStarter.isEnabled_stopDischargeOnDeactivate == true then
			-- Logging.warning("stoppppp")
				-- superFunc(self)
			-- end
			-- Logging.warning("fin")
		-- end)
	-- end
	
	if self.spec_drivable ~= nil then
		self.getIsPowered = Utils.overwrittenFunction(self.getIsPowered, function (self, superFunc)
			-- Trying to steer without the engine running?
			if self.spec_drivable.lastInputValues.axisSteer ~= 0 then
				if g_engineStarter.multiShared_steerable == 2 then
					return true
				end
			end

			return superFunc(self)
		end)
	end

	-- Allow pipes to discharge while not connected
	if self.spec_pipe ~= nil then
		self.handleDischargeRaycast = Utils.overwrittenFunction(self.handleDischargeRaycast, function (self, superFunc, dischargeNode, hitObject, hitShape, hitDistance, hitFillUnitIndex, hitTerrain)
			local spec = self.spec_pipe

			if spec.automaticDischarge then
				local isPowered
				if g_engineStarter.multiShared_dischargeable == 2 then
					isPowered = true
				else
					isPowered = self:getIsPowered()
				end

				local stopDischarge = false

				if isPowered and hitObject ~= nil then
					local fillType = self:getDischargeFillType(dischargeNode)
					local allowFillType = hitObject:getFillUnitAllowsFillType(hitFillUnitIndex, fillType)

					if allowFillType and hitObject:getFillUnitFreeCapacity(hitFillUnitIndex, fillType, self:getOwnerFarmId()) > 0 then
						self:setDischargeState(Dischargeable.DISCHARGE_STATE_OBJECT, true)
					else
						stopDischarge = true
					end
				elseif isPowered and spec.toggleableDischargeToGround then
					self:setDischargeState(Dischargeable.DISCHARGE_STATE_GROUND, true)
				else
					stopDischarge = true
				end

				if stopDischarge and self:getDischargeState() == Dischargeable.DISCHARGE_STATE_OBJECT then
					self:setDischargeState(Dischargeable.DISCHARGE_STATE_OFF, true)
				end

				return
			end

			superFunc(self, dischargeNode, hitObject, hitShape, hitDistance, hitFillUnitIndex, hitTerrain)
		end)
	end
end

function EngineStarterSpec:onEnterVehicle()
	-- Check that our functions haven't been overwritten

	-- We need our function at this level for specialisations to report correctly
	if not Vehicle.addPoweredActionEvent(EngineStarter, "validate") then
		-- Logging.info("EngineStarter: Vehicle.addPoweredActionEvent was not our own. Replacing it with our own. Other mods may not function correctly.")
		Vehicle.addPoweredActionEvent = Utils.overwrittenFunction(Vehicle.addPoweredActionEvent, EngineStarter.addPoweredActionEvent)
	end

	-- Make sure the local level hasn't been overwritten
	if not self.addPoweredActionEvent(EngineStarter, "validate") then
		-- Logging.info("EngineStarter: self.addPoweredActionEvent was not our own. Replacing it with our own. Other mods may not function correctly.")
		self.addPoweredActionEvent = Utils.overwrittenFunction(self.addPoweredActionEvent, EngineStarter.addPoweredActionEvent)
	end
end
